#include "blanquita.h"
#include "fondo.h"

char * fichero_video_fondo[]={	FICHERO_VIDEO_FONDO0, FICHERO_VIDEO_FONDO1, 
				FICHERO_VIDEO_FONDO2, FICHERO_VIDEO_FONDO3,
				FICHERO_VIDEO_FONDO4, FICHERO_VIDEO_FONDO5,
				FICHERO_VIDEO_FONDO6, FICHERO_VIDEO_FONDO7 };
char * fichero_video_nave=FICHERO_VIDEO_NAVE;
char * fichero_video_estrella[2]={FICHERO_VIDEO_ESTRELLA0, FICHERO_VIDEO_ESTRELLA1};
char * fichero_video_enemigo=FICHERO_VIDEO_ENEMIGO;

int video_scroll=0, video_scroll_fondo=0;
unsigned int video_scroll_estrella=0;
int video_scroll_estrellaX[2][8]={ { 400, 300, 260, 180, 40, 139, 300, 240 }, { 120, 300, 370, 250, 280, 120,  56, 134 } };
int video_scroll_estrellaY[2][8]={ {  12,  87, 41, 107, 196,  35, 184, 233 }, { 232, 171, 156, 83, 101, 58,  72,   5 } };

SDL_Surface *video_fondo[]={ NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL };
SDL_Surface *video_nave=NULL;
SDL_Surface *video_estrella[2]={NULL,NULL};
SDL_Surface *video_enemigo[NUM_ENEMIGOS];
SDL_Surface *video_screen=NULL;


//==========================================================================
//PARA HACER EL SCROLL DEL FONDO
//==========================================================================
void video_DibujarFondo()
{
	int i,j,io;
	SDL_Rect RectDestino;
	
	io=video_scroll;
	for(i=0;i<12;i++)
		for(j=0;j<10;j++)
		{
			RectDestino.x=(i*32)-video_scroll_fondo;
			RectDestino.y=j*24;
			SDL_BlitSurface(video_fondo[fondo[j][i+io]],NULL,video_screen,&RectDestino);
		}
	video_scroll_fondo+=2;
	if (video_scroll_fondo>31)
	{
		video_scroll_fondo=0;
		video_scroll++;
		if (video_scroll>39)
		{
			video_scroll=0;
		}
	}
	video_scroll_estrella++;
	for(i=0;i<8;i++)
		for(j=0;j<2;j++)
		{
			RectDestino.x=video_scroll_estrellaX[j][i];
			RectDestino.y=video_scroll_estrellaY[j][i];
			SDL_BlitSurface(video_estrella[j],NULL,video_screen,&RectDestino);
			video_scroll_estrellaX[j][i]-=(i+4);
			if (video_scroll_estrellaX[j][i]<-50)
			{
				io=video_scroll_estrella%FONDO_ESTRELLA;
				video_scroll_estrellaX[j][i]=400+io;
				video_scroll_estrellaY[j][i]=fondo_estrella[io];
			}
		}
}


//===========================================================================
//PROCESO DE LA NAVE
//===========================================================================
void video_dibujanave()
{    
	SDL_Rect    RectOrigen, RectDestino;
     
	RectOrigen.x = 0;
	RectOrigen.y = 0;
	RectOrigen.w = video_nave->w;
	RectOrigen.h = video_nave->h;
	RectDestino.w = RectOrigen.w;
	RectDestino.h = RectOrigen.h;

	RectDestino.x = naveX;
	RectDestino.y = naveY;
        
        SDL_BlitSurface(video_nave, &RectOrigen, video_screen, &RectDestino);
    
}


//===========================================================================
//DIBUJA LOS ENEMIGOS
//===========================================================================
void video_dibujaenemigos() 
{    
        SDL_Rect    RectOrigen, RectDestino;

        int i;
        for(i=0;i<NUM_ENEMIGOS;i++)
        {
           RectOrigen.x = 0;
           RectOrigen.y = 0;
           RectOrigen.w = video_enemigo[i]->w;
           RectOrigen.h = video_enemigo[i]->h;
           RectDestino.w = RectOrigen.w;
           RectDestino.h = RectOrigen.h;

           RectDestino.x = enemigoX[i];
           RectDestino.y = enemigoY[i];
        
           SDL_BlitSurface(video_enemigo[i], &RectOrigen, video_screen, &RectDestino);
        }
} 



SDL_Surface * video_CargarIMG(char* szImg)
{
    SDL_Surface *temp;	/* Surface temporal para cargar la imagen */
    SDL_Surface *final; /* Surface donde quedar la imagen optimizada */

    /* Cargamo la imagen de forma normal*/
    if ((temp = SDL_LoadBMP(szImg))==NULL)
	return NULL;

    /* SDL_SetColorKey india a SDL que no debe copiar el color indicado
       al hacer un Blit, de esa manera ese color ser trasparente.
       La bandera SDL_RLEACCEL hace que SDL utiliza optimizacin para
       mayor velocidad al momento de hacer el Blit */
    SDL_SetColorKey(temp, SDL_SRCCOLORKEY,  SDL_MapRGB(temp->format, 0,255,0));

    /* Ahora optimizamos la imagen convirtiendola al fotmato que se
       est utilizando actualmente, as SDL no tendr que ocupar tiempo
       convirtindola cada vez que hagamos un Blit */
    final = SDL_DisplayFormat(temp);

    if (final == NULL)
	/* Si la imagen, por alguna razn, no se pudo optimizar,
	   simplemente devolveremos el puntero a la imagen original,
	   Esta se podr utilizar, no tn rpido pero se podr utilizar. */
        final = temp;
    else
    	/* Liberamos la imagen temporal ya que la fina est bien*/
        SDL_FreeSurface(temp);

    /* Devolvemos el puntero a la imagen cargada */
    return final;
}


void video_dibuja()
{
	video_DibujarFondo(); 
	video_dibujanave();
	video_dibujaenemigos();
	SDL_Flip(video_screen);

}

int video_inicia()
{
   	int i;
	video_screen=SDL_SetVideoMode(320, 240, 8, SDL_DOUBLEBUF);
	for (i=0;i<8;i++)
	{
		if ((video_fondo[i]=SDL_LoadBMP(fichero_video_fondo[i]))==NULL)
			return -5;
	}
	for(i=0;i<2;i++)
		if ((video_estrella[i] = video_CargarIMG(fichero_video_estrella[i]))==NULL)
			return -4;
	if ((video_nave = video_CargarIMG(fichero_video_nave))==NULL)
		return -2;
        for(i=0;i<NUM_ENEMIGOS;i++)
        {
	       if ((video_enemigo[i] = video_CargarIMG(fichero_video_enemigo))==NULL)
                  return -3;
	}
	return 0;
}

void video_fin()
{
}
